import mongoose from 'mongoose'
import { historySchema } from './core/basicSchema'

const agencySchema = new mongoose.Schema({
  name: String,
  __history: [historySchema]
})

const jobSchema = new mongoose.Schema({
  type: {type: String, enum: ['catwalk', 'photoshoot', 'commercial']},
  description: String,
  salery: Number
})

export const modelSchema = new mongoose.Schema({
  name: String,
  jobs: [jobSchema],
  agencies: String,
  __history: historySchema
})

export default mongoose.model('Model', modelSchema)
